# ssb-pataka

A `secret-stack` plugin which provides:
- a graphql API for pataka
- a web-server that hosts a web-registration page

Has dependencies:
- ssb-profile
- ssb-tribes
  - this is only used for encrypting registrations sent from web-form

## Config

```js
{
  pataka: {
    allowedOrigins: [
      'some-hapu.ahau.io', // example
      'localhost:8000' // for local access if using default port
    ],
    webRegistration: {
      port: 8000,      // port form is served on
    },
    supportedTribes: [
      '%2Sn8sdDl5+cJqrxo2JdVACReYudCbYQAkB0sRHEZARU=.cloaked'
    ]
  },
  serveBlobs: {
    hostname: 'some-hapu.ahau.io',
    port: 28088
  }
}
```

You will need to set `allowedOrigins` for your registration page to be allowed
to call your graphql API.

If `config.pataka.supportedTribes` is set, then only the groupIds of tribes in
that Array will be shown as options for tribes to register for. Further, if
there is only on tribe listed, users will be automatically routed to the
registration page of that tribe.

### ENV

`AHAU_LOGGING=true` turns on verbose logging


## Development

Setup:
```bash
npm i
cd ui && npm i
```

In different terminal windows:
1. `cd ui && npm run dev` (wait for this to be ready)
2. `npm run dev` (run this is root of this project)

This will start up a pataka in development mode.

If you want to test out that the web-registraion is being served correctly from
the built UI:
1. `cd ui && npm run build`
2. `cd .. && node test/test-bot.js`

when not required into another file, test-bot starts up a temp instance, and if
`NODE_ENV` is not set then it will run in production mode, serving the built
files.

## Publishing

```bash
npm publish
```

Note that this auto-builds the UI before publishing (see script: `prepublishOnly`)

